//allows for printing with features, but uses more memory
#define RPRINTF_FLOAT
#define RPRINTF_COMPLEX

#include "hardware.h"
#include "VR_library.h"		//voice recognition library


// Initialise the hardware
void appInitHardware(void) {
	initHardware();


}

// Initialise the software
TICK_COUNT appInitSoftware(TICK_COUNT loopStart){

	delay_ms(1200);//Axon II bootup time

	rprintf("\n\nAxon Initiated\n");

	VR_Module_init();

	return 0;
}

 // robot go_Back Function decleration

void go_back (void)

 {
  motor_left.setSpeed(400);
  motor_right.setSpeed(400);
 }
				///////////////////////////////

// robot go_forward function declration 
void go_forward (void)
 {
  motor_left.setSpeed(100);
  motor_right.setSpeed(100);
 }
				/////////////////////////////

// robot go_left function declration 
void go_left (void)
 {
  motor_left.setSpeed(400);
  motor_right.setSpeed(100);
  delay_ms(1300);
  motor_left.setSpeed(0);
  motor_right.setSpeed(0);
 }
				/////////////////////////////

// robot go_rightfunction declration 
void go_right(void)
 {
  motor_left.setSpeed(100);
  motor_right.setSpeed(400);
  delay_ms(1300);
  motor_left.setSpeed(0);
  motor_right.setSpeed(0);
 }
				/////////////////////////////

// robot stop function declration 
void robot_stop (void)
 {
  motor_left.setSpeed(0);
  motor_right.setSpeed(0);
 }
				/////////////////////////////

// This is the main loop
TICK_COUNT appControl(LOOP_COUNT loopCount, TICK_COUNT loopStart) {
	int8_t voice_command=-2;

	//start voice recognition (note: it times out)
	VR_Module_start_recognition(VR_group);//group B
	
	while(voice_command == -2)
		{
		rprintf("step2");
		voice_command = VR_Module_get_result();
		}

	if(voice_command >= 0)
		{
		rprintf("\nvoice command is: ");
		if(VR_group==1 && voice_command==0)
			{
			rprintf(" THAI");
			VR_group=2;
			}
		else if(VR_group==2 && voice_command==0)
			{
			rprintf(" ENGLISH");
			VR_group=1;
			}
			else if((VR_group==1 && voice_command==0) 
			{
			go_forward();
			delay_ms(5000);
			}
		else if((VR_group==1 && voice_command==1) 
			{
			go_back();
			delay_ms(5000);
			}
		else if((VR_group==1 && voice_command==2) 
			{
			go_left();
			delay_ms(5000);
			}
		else if((VR_group==1 && voice_command==3) 
			{
			go_right();
			delay_ms(1500);
			}
		else if((VR_group==1 && voice_command==4) 
			{
			go_back();
			delay_ms(5000);
			go_forward();
			delay_ms(5000);
			go_left();
			delay_ms(1500);
			gor_right();
			delay_ms(1500);
			go_forward();
			}
		else if((VR_group==1 && voice_command==5) 
			{
			robot_stop();
			}
		else if(voice_command==4)
			{
			rprintf(" DANCE");
			}
		// -------- Start Switch/Button-------
	// Switch/Button - see switch.h
	
	// To test if it is pressed then
	//if(button.pressed()){
		// pressed
	//}
	
	// To test if it is released then
	//if(button.released()){
		// released
	//}
	// -------- End   Switch/Button-------

	// -------- Start Marquee-------
	//{		
		// A marquee is a 'Stream' so can use the print calls - 
		// but need to end with '\n' to start scrolling
	
		// If the endDelay is non-zero then the marquee will scroll
		// forever or until you call: marquee.stop();
		
		// If the endDelay is zero then the marquee will stop once
		// the entire line has been shown ('one-shot' mode)
		
		// In 'one-shot' mode then you may want to make sure that
		// a previous line has finished before you display a second line.
		// This can be done as follows:-
		//marquee.setEndDelay(0); // Make sure we are in one-shot mode
		//if(marquee.isActive()==FALSE){
		  //   if(loopCount==1){
		    // 	marquee.print_P(PSTR("ABCDEFGHIJKLMNOPQRSTUVWXYZ\n"));
		     //}else{
			//	marquee.print_P(PSTR("Loop="));
			//	marquee.print(loopCount);
			//	marquee.println();
		     //}
		//}
			
	//}
	// -------- End   Marquee-------

	// -------- Start LED-------
	// The LED can be manipulated using the calls in led.h
	
	// To turn the LED on:-
	led.on();
	
	// To turn the LED off:-
	led.off();
	// -------- End   LED-------

	// -------- Start Text to Speech-------
	// Say an English phrase
	speech.print("Death to all humans");
	// -------- End   Text to Speech-------

	// -------- Start PING sonar-------
	{
		// Read the PING sonar and store the results
		sonar.read();
		
		// Retrieve the value and print it out
		DISTANCE_TYPE cm = sonar.getDistance();
		PRINTF(stdout,"Distance=%u\n",cm);
			
		// or dump using:
		sonar.dump();
	}
	// -------- End   PING sonar-------

	//stop further motion
	robot_stop();
	return 0;
}

