/*
		This file has been auto-generated by WebbotLib tools V1.1
				** DO NOT MODIFY BY HAND **
*/
#ifndef _LIB_HARDWARE_C_
#define _LIB_HARDWARE_C_
#include "../hardware.h"

// ------------------- uart1 -------------------
// Make a transmit buffer for uart1
static unsigned char tx_uart1_Buf[80];
static cBuffer tx_uart1_Buffer = MAKE_BUFFER(tx_uart1_Buf);

// Make a receive buffer for uart1
static unsigned char rx_uart1_Buf[80];
static cBuffer rx_uart1_Buffer = MAKE_BUFFER(rx_uart1_Buf);


// Create a routine to write bytes to uart1
// You can set rprintf to use it by calling rprintfInit(&uart1SendByte)
MAKE_WRITER(uart1SendByte){
	return uartSendByte(_C_uart1,byte);
}

// Create a routine to read a byte from uart1
// Returns -1 if there was no data
MAKE_READER( uart1GetByte){
	return uartGetByte(_C_uart1);
}

// Create hardware UART _C_uart1
HW_UART __C_uart1 = MAKE_UART_BUFFERED(&rx_uart1_Buffer,&tx_uart1_Buffer,UCSR1A,UCSR1B,UBRR1L,UBRR1H,UDR1,null,BV(U2X1),D2,D3,&uart1GetByte,&uart1SendByte);

#ifndef USART1_TX_vect
# error Uart1 Tx complete vector undefined
#else
ISR(USART1_TX_vect){
	uartTransmitService(_C_uart1);
}
#endif

#ifndef USART1_RX_vect
# error Uart1 Rx complete vector undefined
#else
ISR(USART1_RX_vect){
	uartReceiveService(_C_uart1);
}
#endif

// ------------------- Voice_Recognition -------------------
// Make a transmit buffer for Voice_Recognition
static unsigned char tx_Voice_Recognition_Buf[20];
static cBuffer tx_Voice_Recognition_Buffer = MAKE_BUFFER(tx_Voice_Recognition_Buf);

// Make a receive buffer for Voice_Recognition
static unsigned char rx_Voice_Recognition_Buf[80];
static cBuffer rx_Voice_Recognition_Buffer = MAKE_BUFFER(rx_Voice_Recognition_Buf);


// Create a routine to write bytes to Voice_Recognition
// You can set rprintf to use it by calling rprintfInit(&Voice_RecognitionSendByte)
MAKE_WRITER(Voice_RecognitionSendByte){
	return uartSendByte(_C_Voice_Recognition,byte);
}

// Create a routine to read a byte from Voice_Recognition
// Returns -1 if there was no data
MAKE_READER( Voice_RecognitionGetByte){
	return uartGetByte(_C_Voice_Recognition);
}

// Create hardware UART _C_Voice_Recognition
HW_UART __C_Voice_Recognition = MAKE_UART_BUFFERED(&rx_Voice_Recognition_Buffer,&tx_Voice_Recognition_Buffer,UCSR0A,UCSR0B,UBRR0L,UBRR0H,UDR0,null,BV(U2X0),E0,E1,&Voice_RecognitionGetByte,&Voice_RecognitionSendByte);

#ifndef USART0_TX_vect
# error Uart0 Tx complete vector undefined
#else
ISR(USART0_TX_vect){
	uartTransmitService(_C_Voice_Recognition);
}
#endif

#ifndef USART0_RX_vect
# error Uart0 Rx complete vector undefined
#else
ISR(USART0_RX_vect){
	uartReceiveService(_C_Voice_Recognition);
}
#endif

// ----------- Define the ADC channels ----------
const uint8_t NUM_ADC_CHANNELS = 16;

// ----------- My devices -----------------------
SWITCH _button_ = MAKE_SWITCH(D5);
SEGLED _led_display_ = MAKE_SEGLED(C3,C2,C0,D6,D7,C4,C5,null,false);
static SEGLED_LIST PROGMEM marquee_list[] = {
	&_led_display_
};
static MAKE_WRITER(marquee_put_char); /* Fwd Def */
MARQUEE _marquee_ = MAKE_MARQUEE(marquee_list,500000,2000000,&marquee_put_char);
// Create a Writer to write to marquee
// Do NOT call it directly instead, to write the char 'A' use:
// 	marqueeGetWriter(&marquee)('A');
static MAKE_WRITER(marquee_put_char){ /* createWriter */
	return marqueeSendByte(&_marquee_,byte);
}
LED _led_ = MAKE_LED(A1,true);
TOSHIBA_TB6612FNG_2pin_MOTOR _motor_left_ = MAKE_TOSHIBA_TB6612FNG_MOTOR_2pin(false,E3,E4);
TOSHIBA_TB6612FNG_2pin_MOTOR _motor_right_ = MAKE_TOSHIBA_TB6612FNG_MOTOR_2pin(false,B4,B5);
static TOSHIBA_TB6612FNG_2pin_MOTOR_LIST PROGMEM motor_bank_list[] = {
	&_motor_left_,
	&_motor_right_
};
TOSHIBA_TB6612FNG_2pin_MOTOR_DRIVER _motor_bank_ = MAKE_TOSHIBA_TB6612FNG_2pin_MOTOR_DRIVER(motor_bank_list);
PingSonar _sonar_ = MAKE_PingSonar(A0);

// ----------- Initialise built in devices ------
void sysInitHardware(void){
	SWITCH_init(&_button_);
	setErrorLog(&uart1SendByte);
	rprintfInit(&uart1SendByte);
	uartInit(_C_uart1,230400);
	segled_init(&_led_display_);
}

// ----------- Initialise my added devices ------
void initHardware(void){
	uartInit(_C_Voice_Recognition,9600);
	toshibaTB6612FNG_2pin_Init(&_motor_bank_,10000);
	speechInit(B7);
	distanceInit(_sonar_);
}
// ----------- Register the statusLED -----------
void registerLED(void){
	statusLEDregister(C1,false);
}

#endif
