#include "../hardware.h"
static const char PROGMEM name_button[] = "button";
static const char PROGMEM name_uart1[] = "uart1";
static const char PROGMEM name_led_display[] = "led_display";
static const char PROGMEM name_marquee[] = "marquee";
static const char PROGMEM name_Voice_Recognition[] = "Voice_Recognition";
static const char PROGMEM name_led[] = "led";
static const char PROGMEM name_motor_left[] = "motor_left";
static const char PROGMEM name_motor_right[] = "motor_right";
static const char PROGMEM name_motor_bank[] = "motor_bank";
static const char PROGMEM name_speech[] = "speech";
static const char PROGMEM name_sonar[] = "sonar";
static const char PROGMEM unknown[] = "?";

#define NUM_DEVICES 11
static const void* PROGMEM tbl[]={
	&_button_, name_button,
	&__C_uart1, name_uart1,
	&_led_display_, name_led_display,
	&_marquee_, name_marquee,
	&__C_Voice_Recognition, name_Voice_Recognition,
	&_led_, name_led,
	&_motor_left_, name_motor_left,
	&_motor_right_, name_motor_right,
	&_motor_bank_, name_motor_bank,
	_speech_, name_speech,
	&_sonar_, name_sonar
	};

const char* getDeviceName(const void* device){
	const char* rtn = unknown;
	for(int i=0 ; i<NUM_DEVICES*2; i+=2){
		const void* addr = (const void*)pgm_read_word(&tbl[i]);
		if( addr == device){
			rtn = (const void*)pgm_read_word(&tbl[i+1]);
		}
	}
	return rtn;
}
